Page MenuHome

2.80 - Py API: Exporters: applied modifiers geometry looses most of orig custom data layers
Closed, ResolvedPublic

Description

System Information
Operating system: Windows-10-10.0.17763 64 Bits
Graphics card: Radeon Pro 580 ATI Technologies Inc. 4.5.13476 Core Profile Context 22.19.170.1536

Blender Version
Broken: version: 2.80 (sub 71), branch: master, commit date: 2019-05-22 06:32, hash: rBc06bd2d18461
Worked: 2019-05-15 23:47, hash: 02a7e57d9c07

Short description of error
If you have an edge split modifier after your Armature modifier...

  • Skin weights are not exported.

Regardless...

  • Shape keys are not exported.

Tested exporting to Unity.
Also importing FBX back into Blender (earlier version listed above)

Exact steps for others to reproduce the error
Export the export collection in the attached scene.

Event Timeline

Malcolm Reed (mal_reed) renamed this task from FBX export broken to 2.80 - FBX export broken.

same issue here, in my case it is: armature & mirrormodifier.

I have issues with shape keys export, the model is totally deformed

Bastien Montagne (mont29) triaged this task as Confirmed, Medium priority.
Bastien Montagne (mont29) raised the priority of this task from Confirmed, Medium to Confirmed, High.

@Sergey Sharybin (sergey) looks like with new system to get meshes with modifiers, we are loosing all (or nearly all) custom data layers, since we basically get mesh from final eval from depsgraph… As far as I remember, with previous system we were getting pretty full set of customdata. :/

Assigning to you to get your feedback, that is more of a design issue first of all: do we consider current behavior as valid and desired one? if so, that’s going to make exporters life much harder.

Bastien Montagne (mont29) renamed this task from 2.80 - FBX export broken to 2.80 - Py API: Exporters: applied modifiers geometry looses most of orig custom data layers.May 24 2019, 11:09 AM

Stealing it back now that I should have a way to fix it ;)

@Bastien Montagne (mont29), i made a mistake in the commit message: it is preserve, not keep (forgot to update it, duh).

Hi Guys,

Just wanted to check if this should have fixed the issue with Shape Keys being lost in export?
There were two errors reported in the initial post. Seems the direction went with the modifier stack. Was the Shape Key issue picked up on? Perhaps that is on a separate ticket?

Shape Keys not exported via FBX in version: 2.80 (sub 72), branch: blender2.7, commit date: 2019-05-28 21:07, hash: rB9bae9b634ec6

Keep up the great work,

Malcolm

Ah, forgot to explain that. No, shape keys are always lost when exporting a mesh with modifiers (other than the armature one), as they only apply to raw mesh, before any modifier takes place. The only way to keep them in FBX is either to export without modifiers, or to ensure exported objects only have an armature modifier, nothing else.

Thanks for the explanation.

In that case I may need to supply another test file? As even if it only has an armature the shape keys are lost.

I see this in my own working files. I can export Shape Keys successfully from the earlier 2.80 version listed, but not in these later ones.

Hope that helps?

Cheers,
Malcolm

Woops yes indeed, some glitch in the system! Fix incoming, thanks for reporting.

You are most welcome.

Could I be really cheeky and ask you to take a quick look at another bug I reported.
https://developer.blender.org/T64446
Would love to know if this is a bug / working as expected? Currently it's causing me lots of pain :)

Cheers again,
Malcolm